.\"
.\" Copyright (c) 2007 The DragonFly Project.  All rights reserved.
.\" 
.\" Redistribution and use in source and binary forms, with or without
.\" modification, are permitted provided that the following conditions
.\" are met:
.\" 
.\" 1. Redistributions of source code must retain the above copyright
.\"    notice, this list of conditions and the following disclaimer.
.\" 2. Redistributions in binary form must reproduce the above copyright
.\"    notice, this list of conditions and the following disclaimer in
.\"    the documentation and/or other materials provided with the
.\"    distribution.
.\" 3. Neither the name of The DragonFly Project nor the names of its
.\"    contributors may be used to endorse or promote products derived
.\"    from this software without specific, prior written permission.
.\" 
.\" THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
.\" ``AS IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
.\" LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
.\" FOR A PARTICULAR PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL THE
.\" COPYRIGHT HOLDERS OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
.\" INCIDENTAL, SPECIAL, EXEMPLARY OR CONSEQUENTIAL DAMAGES (INCLUDING,
.\" BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
.\" LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED
.\" AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
.\" OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT
.\" OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
.\" SUCH DAMAGE.
.\"
.\" $DragonFly: src/share/man/man4/et.4,v 1.2 2007/10/23 14:28:42 sephe Exp $
.\"
.Dd October 11, 2007
.Dt ET 4
.Os
.Sh NAME
.Nm et
.Nd "Agere ET1310 10/100/Gigabit Ethernet device"
.Sh SYNOPSIS
.Cd "device miibus"
.Cd "device et"
.Pp
Alternatively, to load the driver as a module at boot time, place the
following line in
.Pa /boot/loader.conf :
.Bd -literal -offset indent
if_et_load="YES"
.Ed
.Sh DESCRIPTION
The
.Nm
driver supports the PCIe Ethernet adapters based on Agere ET1310.
.Pp
Support for Jumbo Frames is provided via the interface MTU setting.
Selecting an MTU larger than 1500 bytes with the
.Xr ifconfig 8
utility configures the adapter to receive and transmit Jumbo Frames.
The maximum MTU setting for Jumbo Frames is 15572.
This value coincides with the maximum Jumbo Frames size of 15594.
.Pp
The
.Nm
driver supports the following
.Ar media
types:
.Pp
.Bl -tag -width 10baseT/UTP -compact
.It Cm autoselect
Enable autoselection of the media types and options
.Pp
.It Cm 10baseT/UTP
Set 10Mbps operation.
The
.Ar mediaopt
option can also be used to select either
.Ar full-duplex
or
.Ar half-duplex
modes.
.Pp
.It Cm 100baseTX
Set 100Mbps (Fast Ethernet) operation.
The
.Ar mediaopt
option can also be used to select either
.Ar full-duplex
or
.Ar half-duplex
modes.
.Pp
.It Cm 1000baseT
Set 1000Mbps (Gigabit Ethernet) operation.
The
.Ar mediaopt
option can only be set
.Ar full-duplex
mode.
.El
.Pp
The
.Nm
driver supports the following
.Ar media
options:
.Pp
.Bl -tag -width full-duplex -compact
.It Cm full-duplex
Force full duplex operation.
.Pp
.It Cm half-duplex
Force half duplex operation.
.El
.Pp
Note that the 1000baseT media type is only available
if it is supported by the adapter.
For more information on configuring this device,
see
.Xr ifconfig 8 .
.Sh TUNABLES
.Bl -tag -width ".Va hw.et.rx_intr_npkts"
.It Va hw.et.rx_intr_npkts
This value controls how many packets should be recevied
before a receive interrupt is generated.
The default value is 32.
.It Va hw.et.rx_intr_delay
This value delays the generation of receive interrupts
in units of 10 microseconds (I guess).
It is used together with
.Va hw.et.rx_intr_npkts
to achieve RX interrupt moderation.
The default value is 20.
.It Va hw.et.tx_intr_nsegs
This value controls how many segments (not packets) should be transmitted
before a transmit interrupt is generated.
The default value is 126.
.It Va hw.et.timer
This value controls how often the a timer interrupt should be generated.
It is used together with
.Va hw.et.tx_intr_nsegs
to achieve TX interrupt moderation.
The default value is 1000000000 (nanoseconds).
.El
.Sh SEE ALSO
.Xr arp 4 ,
.Xr ifmedia 4 ,
.Xr miibus 4 ,
.Xr netintro 4 ,
.Xr ng_ether 4 ,
.Xr vlan 4 ,
.Xr ifconfig 8
.Sh HISTORY
The
.Nm
device driver first appeared in
.Dx 1.11 .
.Sh AUTHORS
.An -nosplit
The
.Nm
driver was written by
.An Sepherosa Ziehau
.Aq sepherosa@gmail.com .
